<div align="center">

  <h1><code>helper-wasm</code></h1>

  <strong>js拓展辅助工具包 使用<a href="https://github.com/rustwasm/wasm-pack">wasm-pack</a>.</strong>

  <p>
    <a href="https://travis-ci.org/rustwasm/wasm-pack-template"><img src="https://img.shields.io/travis/rustwasm/wasm-pack-template.svg?style=flat-square" alt="Build Status" /></a>
  </p>

  <h3>
    <a href="https://rustwasm.github.io/docs/wasm-pack/tutorials/npm-browser-packages/index.html">Tutorial</a>
    <span> | </span>
    <a href="https://discordapp.com/channels/442252698964721669/443151097398296587">Chat</a>
  </h3>

  <sub>Built with 🦀🕸 by <a href="https://rustwasm.github.io/">The Rust and WebAssembly Working Group</a></sub>
</div>

## 关于

[**📚 阅读此模板教程！ 📚**][template-docs]

该项目旨在将 Rust 库编译成 WebAssembly 和 将生成的包发布到 NPM。

请务必查看 [其他 `wasm-pack` 在线教程][tutorials] 关于`wasm-pack`的模板和用法。

[tutorials]: https://rustwasm.github.io/docs/wasm-pack/tutorials/index.html
[template-docs]: https://rustwasm.github.io/docs/wasm-pack/tutorials/npm-browser-packages/index.html

## 🚴 用法

### 🛠️ 使用 `wasm-pack` 构建

```
wasm-pack build --scope feewee
```

### 🔬 使用 `wasm-pack test` 在无头浏览器中进行测试

```
wasm-pack test --headless --firefox
```

### 🎁 使用 `wasm-pack publish` 发布到 NPM

```
wasm-pack publish
```

## 🔋 使用到的技术和依赖包

* [`wasm-bindgen`](https://github.com/rustwasm/wasm-bindgen) for communicating
  between WebAssembly and JavaScript.
* [`console_error_panic_hook`](https://github.com/rustwasm/console_error_panic_hook)
  for logging panic messages to the developer console.
* [`wee_alloc`](https://github.com/rustwasm/wee_alloc), an allocator optimized
  for small code size.

## 🚨 项目注意事项
1. 关于`wasm-pack build`编译后的发布依赖包：
需要手动去编译好的`pkg`文件夹里，执行`npm publish`命令发布。
需要注意注意的是由于打包是加了`--scope feewee`发布是也需要加`--access public`让这个包公开可见。同时由于这个包是发布在公司私有仓库的所以需要切换本地npm仓库源并登陆。
具体账号是： 

|账号|密码|邮箱|
|:---|:---:|---:|
|feewee|***|zhangzw@feewee.cn|

2. 编译的时候加上`--features=debug-log`这个参数的话会以debug形式打印一些调试用的参数。同时需要测试的话可以在编译的时候加上`--target web`指定为web模式的编译这样就可以直接在html文件里使用。完整的调试命令如下（仅供参考）：
`wasm-pack build --features=debug-log --target web --scope feewee` 。
同时执行这个命令后可以起一个web容器访问`examples`里的index查看。
推荐使用cargo安装`basic-http-server` 来快速启动web容器。

